org.apache.lucene.geo

## Class XYPolygon

- java.lang.Object
- - org.apache.lucene.geo.XYPolygon

-     public class XYPolygon
      extends Object

  Represents a polygon in cartesian space. You can construct the Polygon directly with `double[]`, `double[]` x, y arrays coordinates.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `double` | `maxX` maximum x of this polygon's bounding box area
    `double` | `maxY` maximum y of this polygon's bounding box area
    `double` | `minX` minimum x of this polygon's bounding box area
    `double` | `minY` minimum y of this polygon's bounding box area

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XYPolygon(float[] x, float[] y, XYPolygon... holes)` Creates a new Polygon from the supplied x, y arrays, and optionally any holes.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object obj)`
    `XYPolygon[]` | `getHoles()` Returns a copy of the internal holes array
    `double[]` | `getPolyX()` Returns a copy of the internal x array
    `double` | `getPolyX(int vertex)` Returns x value at given index
    `double[]` | `getPolyY()` Returns a copy of the internal y array
    `double` | `getPolyY(int vertex)` Returns y value at given index
    `GeoUtils.WindingOrder` | `getWindingOrder()` Returns the winding order (CW, COLINEAR, CCW) for the polygon shell
    `int` | `hashCode()`
    `int` | `numHoles()` returns the number of holes for the polygon
    `int` | `numPoints()` returns the number of vertex points
    `String` | `toGeoJSON()` prints polygons as geojson
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### minX

          public final double minX

      minimum x of this polygon's bounding box area

    - #### maxX

          public final double maxX

      maximum x of this polygon's bounding box area

    - #### minY

          public final double minY

      minimum y of this polygon's bounding box area

    - #### maxY

          public final double maxY

      maximum y of this polygon's bounding box area

  - ### Constructor Detail

    - #### XYPolygon

          public XYPolygon(float[] x,
                           float[] y,
                           XYPolygon... holes)

      Creates a new Polygon from the supplied x, y arrays, and optionally any holes.

  - ### Method Detail

    - #### numPoints

          public int numPoints()

      returns the number of vertex points

    - #### getPolyX

          public double[] getPolyX()

      Returns a copy of the internal x array

    - #### getPolyX

          public double getPolyX(int vertex)

      Returns x value at given index

    - #### getPolyY

          public double[] getPolyY()

      Returns a copy of the internal y array

    - #### getPolyY

          public double getPolyY(int vertex)

      Returns y value at given index

    - #### getHoles

          public XYPolygon[] getHoles()

      Returns a copy of the internal holes array

    - #### getWindingOrder

          public GeoUtils.WindingOrder getWindingOrder()

      Returns the winding order (CW, COLINEAR, CCW) for the polygon shell

    - #### numHoles

          public int numHoles()

      returns the number of holes for the polygon

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### toGeoJSON

          public String toGeoJSON()

      prints polygons as geojson

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.